#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/poll.h>
#include <unistd.h>
#include "xthr.h"
#include "xt_int.h"

int threads = 1000;

xt_mutex_t mutex;

void *
start(void *arg) {
	sleep(1);
	threads--;
	return NULL;
}

int
main() {
	int i = threads;
	xio_thread_attrs attrs = { 0, 4096 };
	xio_thread_t thread;
	struct pollfd fds[2];
	int ret;

	while(i--) {
		int q = -1;
		if(i == 0) {
			/* Make the last thread joinable */
			attrs.joinable = 1;
		}
		if(xio_thread_create(&thread, &attrs, start, (void *)q) == -1)
			perror("Can't create thread");
	}

	printf("\nThreads created\n");
	printf("Done: %d unfinished\n", threads);
	xio_thread_join(thread, NULL);
	printf("Done: %d unfinished\n", threads);

	fflush(stdout);

	fds[0].fd = 0;
	fds[0].events = POLLIN;
	fds[0].revents = 123;

	fds[1].fd = 2;
	fds[1].events = POLLOUT;
	fds[1].revents = 234;

	ret = poll(fds, sizeof(fds)/sizeof(fds[0]), 0);
	printf("Poll:\n");
	printf(" ret = %d (%s)\n", ret, strerror(ret==-1?errno:0));
	printf(" r[0] = %d\n", fds[0].revents);
	printf(" r[1] = %d\n", fds[1].revents);


	return 0;
}
