#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <assert.h>
#include "xthr.h"

int ok = 0;

void *
worker(void *arg) {
	int s = (int)arg;
	char buf[256];
	char *reply[] =
		{
		"HTTP/1.0 200 OK, everything's fine\n"
		"Content-Type: text/plain\n"
		"\n",

"THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.",

		};
	int i;

	read(s, buf, sizeof(buf) - 1);

	for(i = 0; i < sizeof(reply) / sizeof(char *); i++)
		write(s, reply[i], strlen(reply[i]));

	close(s);

	ok++;

	return NULL;
}

void *
server(void *arg) {
	int s, c;
	struct sockaddr_in sin;

	printf("Server started\n");

	s = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(s == -1) {
		perror("Can't create server socket");
		return NULL;
	}

	c = 1;
	setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &c, sizeof(c));
	c = 1;
	setsockopt(s, SOL_SOCKET, SO_REUSEPORT, &c, sizeof(c));

	c = 1;
	setsockopt(s, IPPROTO_TCP, TCP_NODELAY, &c, sizeof(c));

	memset(&sin, 0, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_len = sizeof(sin);
	sin.sin_addr.s_addr = 0; //htonl(INADDR_LOOPBACK);
	sin.sin_port = htons(3454);

	if(bind(s, (struct sockaddr *)&sin, sizeof(sin))) {
		perror("Can't bind() server socket");
		return NULL;
	}

	if(listen(s, -1)) {
		perror("Can't listen() on server socket");
		return NULL;
	}

	if(0) {
		struct accept_filter_arg afa;
		memset(&afa, 0, sizeof(afa));
		strcpy(afa.af_name, "httpready");

		c = setsockopt(s, SOL_SOCKET, SO_ACCEPTFILTER,
			&afa, sizeof(afa));
		if(c == -1) {
			perror("Can't install accept_filter");
		}
	}

	printf("Server listening on socket %d\n", s);

	while(1) {
		c = accept(s, NULL, NULL);
		if(c == -1) {
			//perror("Accept failed");
			continue;
		}

		if(xio_thread_create(NULL, NULL, worker, (void *)c) == -1) {
			perror("Could not create worker thread");
			close(c);
		}
	}

	close(s);

	ok++;

	return NULL;
}

void *
client(void *arg) {
	int s;
	struct sockaddr_in sin;
	FILE *f;
	char buf[256];

	s = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(s == -1) {
		perror("Can't create client socket");
		return NULL;
	}

	printf("Client started: fd=%d\n", s);

	memset(&sin, 0, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
	sin.sin_port = htons(3454);

	if(connect(s, (struct sockaddr *)&sin, sizeof(sin))) {
		perror("Can't connect() client socket");
		return NULL;
	}

	f = fdopen(s, "r+");
	assert(f);
	setvbuf(f, NULL, _IOLBF, 0);

	printf("Client connected!\n");

	fprintf(f, "GET / HTTP/1.0\n\n");

	while(fgets(buf, sizeof(buf), f)) {
		printf("CL: [%s]\n", buf);
	}

	printf("Client finished\n");

	fclose(f);

	ok++;

	return NULL;
}

int
main() {
	xio_thread_t s_thread;
	xio_thread_t c_thread;
	int ret;
	xio_thread_attrs attrs = { 1, 0 };

	if(xio_thread_create(&s_thread, &attrs, server, NULL) == -1) {
		perror("Can't create thread");
		exit(1);
	}

	if(xio_thread_create(&c_thread, &attrs, client, NULL) == -1) {
		perror("Can't create thread");
		exit(1);
	}

	if(xio_thread_create(&c_thread, &attrs, client, NULL) == -1) {
		perror("Can't create thread");
		exit(1);
	}

	printf("Threads created\n");

	ret = xio_thread_join(c_thread, NULL);
	printf("Client join: %d\n", ret);

	printf("Finishing main()\n");

	assert(ok == 4);

	return 0;
}


