#include "xt_int.h"

int
accept(int s, struct sockaddr *addr, socklen_t *addrlen) {
	int ret;

	/* Lock file descriptor */
	_xt_fd_lock(s, POLLIN);

	while(1) {
		ret = _xt_sys_accept(s, addr, addrlen);
		if(ret != -1) {
			/* Clear all flags from the newly-created socket */
			_xt_fd_clear(ret, ~0);
			break;
		}

		switch(errno) {
		case EAGAIN:	/* Operation would block */
			_xt_fd_clear(s, XFD_READABLE);
			_xt_fd_wait(s, POLLIN);
		case EINTR:	/* Really slow device */
			THR_SWITCH_CONTEXT;
			continue;
		}

		break;
	}

	/* Unlock file descriptor */
	_xt_fd_unlock(s, POLLIN);

	return ret;
}
