#include "xt_int.h"

int
bind(int s, const struct sockaddr *addr, socklen_t addrlen) {
	int ret;

	/* Lock file descriptor */
	_xt_fd_lock(s, POLLIN | POLLOUT);

	while(1) {
		ret = _xt_sys_bind(s, addr, addrlen);
		if(ret != -1)
			return ret;

		switch(errno) {
		case EAGAIN:	/* Resource temporarily unavailable */
		case EINTR:	/* Really slow device */
			THR_SWITCH_CONTEXT;
			continue;
		default:
			return ret;
		}

		break;
	}

	/* Unlock file descriptor */
	_xt_fd_unlock(s, POLLIN | POLLOUT);

	return -1;
}
