#include "xt_int.h"

int
connect(int s, const struct sockaddr *name, socklen_t namelen) {
	int ret;

	ret = _xt_sys_connect(s, name, namelen);
	if(ret != -1)
		return ret;

	if(errno == EINPROGRESS) {

		/* Lock file descriptor */
		_xt_fd_lock(s, POLLOUT);

		_xt_fd_clear(s, XFD_WRITEABLE);
		_xt_fd_wait(s, POLLOUT);
		THR_SWITCH_CONTEXT;

		/* Unlock file descriptor */
		_xt_fd_unlock(s, POLLOUT);
		return 0;
	}

	return ret;
}
