#include "xt_int.h"

/*
 * Open file, assuring it is in the non-blocking mode.
 */
int
open(const char *path, int flags, ...) {
	va_list ap;
	int fd;

	/*
	 * Indicate we want the file to be opened in the non-blocking mode.
	 */
	flags |= O_NONBLOCK;

	if(flags & O_CREAT) {
		mode_t mode;
		/*
		 * Fetch user-supplied mode,
		 * if it seems that it will be necessary.
		 */
		va_start(ap, flags);
		mode = va_arg(ap, mode_t);
		va_end(ap);

		fd = _xt_sys_open(path, flags, mode);
	} else {
		fd = _xt_sys_open(path, flags);
	}

	/* Initialize fd wrapper */
	_xt_fd_clear(fd, ~0);

	return 0;
}
