#include "xt_int.h"

/*
 * Create a pipe and set it non-blocking.
 */
int
pipe(int *fildes)
	int ret;

	ret = _xt_sys_pipe(fildes);

	if(ret == -1)
		return ret;

	/* Set non-blocking I/O. */
	if(_xt_fd_nbio(fildes[0], 0) == -1
	|| _xt_fd_nbio(fildes[1], 0) == -1) {

		close(fildes[0]);
		close(fildes[1]);

		return -1;
	}

	/* Clear flags for the newly-created socket */
	_xt_fd_clear(fildes[0], ~0);
	_xt_fd_clear(fildes[1], ~0);

	return ret;
}
