#include "xt_int.h"

ssize_t
read(int fd, void *buf, size_t nbytes) {
	ssize_t ret;

	/* Lock file descriptor */
	_xt_fd_lock(fd, POLLIN);

	while(1) {
		ret = _xt_sys_read(fd, buf, nbytes);
		if(ret != -1)
			break;

		switch(errno) {
		case EAGAIN:	/* Operation would block */
			_xt_fd_clear(fd, XFD_READABLE);
			_xt_fd_wait(fd, POLLIN);
		case EINTR:	/* Really slow device */
			THR_SWITCH_CONTEXT;
			continue;
		}

		break;
	}

	/* Unlock file descriptor */
	_xt_fd_unlock(fd, POLLIN);

	return ret;
}
