#include "xt_int.h"

unsigned int
sleep(unsigned int seconds) {
	unsigned int unslept;

	/*
	 * Split sleep time into pieces, to not to overflow
	 * timer code which measures events in ticks.
	 */
	while(seconds > 1000) {
		seconds -= 1000;
		unslept = _xt_sleep(1000 * 100);
		if(unslept)
			return ((unslept / 100) + seconds);
	}

	unslept = _xt_sleep(seconds * 100);
	if(unslept)
		return (unslept / 100);

	return 0;
}


int
usleep(unsigned int microseconds) {

	_xt_schedule_wakeup(microseconds / 10000);

	/* Check if thread was interrupted */
	if(_xt_current_thread->timer.state == XTS_RUNNING) {
		_xt_timer_stop(&_xt_current_thread->timer);
		errno = EINTR;
		return -1;
	}

	return 0;
}
