#include "xt_int.h"

/*
 * Create socket, assuring it is in the non-blocking mode.
 */
int
socket(int domain, int type, int protocol) {
	int sock;

	sock = _xt_sys_socket(domain, type, protocol);

	if(sock == -1)
		return sock;

	/*
	 * Set the non-blocking mode on socket.
	 */
	if(_xt_fd_nbio(sock, 1)) {
		close(sock);
		return -1;
	}

	_xt_fd_clear(sock, ~0);

	return sock;
}
