#include "xt_int.h"

ssize_t
write(int fd, const void *buf, size_t nbytes) {
	ssize_t ret;

	/* Lock file descriptor */
	_xt_fd_lock(fd, POLLOUT);

	while(1) {
		ret = _xt_sys_write(fd, buf, nbytes);
		if(ret != -1)
			break;

		switch(errno) {
		case EAGAIN:
			_xt_fd_clear(fd, XFD_WRITEABLE);
			_xt_fd_wait(fd, POLLOUT);
		case EINTR:
			THR_SWITCH_CONTEXT;
			continue;
		}
	
		break;
	}

	/* Unlock file descriptor */
	_xt_fd_unlock(fd, POLLOUT);

	return ret;
}
