/*
 * Miscellaneous internal functions and definitions.
 */
#ifndef	__XT_INT_H__
#define	__XT_INT_H__

#include "headers.h"
#include "xt_stack.h"
#include "xt_structs.h"
#include "xt_sysdeps.h"
#include "xt_sched.h"
#include "xt_ring.h"
#include "xt_timer.h"
#include "xt_locks.h"
#include "xt_fd.h"
#include "xthr.h"

/*
 * Syscalls
 */
extern ssize_t	(*_xt_sys_open)(const char *path, int flags, ...);
extern int	(*_xt_sys_close)(int fd);
extern ssize_t	(*_xt_sys_read)(int fd, void *buf, size_t nbytes);
extern ssize_t	(*_xt_sys_write)(int fd, const void *buf, size_t nbytes);
extern int	(*_xt_sys_socket)(int domain, int type, int protocol);
extern int	(*_xt_sys_bind)(int s, const struct sockaddr *addr, socklen_t addrlen);
extern int	(*_xt_sys_accept)(int s, struct sockaddr *addr, socklen_t *addrlen);
extern int	(*_xt_sys_connect)(int s, const struct sockaddr *name, socklen_t namelen);
extern int	(*_xt_sys_nanosleep)(const struct timespec *rqtp, struct timespec *rmtp);
extern int	(*_xt_sys_pipe)(int *fildes);

/*
 * Standard C library API
 */
extern FILE *	(*_xt_lib_fopen)(const char *path, const char *mode);
extern FILE *	(*_xt_lib_fdopen)(int fildes, const char *mode);
extern FILE *	(*_xt_lib_freopen)(const char *path, const char *mode, FILE *stream);
extern int	(*_xt_lib_vfprintf)(FILE *stream, const char *format, va_list);
extern char *	(*_xt_lib_fgets)(char *str, int size, FILE *stream);
extern size_t	(*_xt_lib_fread)(void *ptr, size_t size, size_t nmemb, FILE *stream);
extern size_t	(*_xt_lib_fwrite)(const void *ptr, size_t size, size_t nmemb, FILE *stream);
extern void	(*_xt_lib_clearerr)(FILE *stream);

/* Current thread */
extern xt_thread_t *_xt_current_thread;

/*
 * Create a new thread structure.
 */
xt_thread_t *_xt_new_xio_thread(xio_thread_attrs *attrs,
	void *(*start_routine)(void *arg), void *arg, int run_it);

#endif	/* __XT_INT_H__ */
