/*
 * Locking API
 */
#ifndef	__XT_LOCKS_H__
#define	__XT_LOCKS_H__

/*
 * Mutex
 */
typedef struct xt_mutex_s {
	struct xt_thread_s *owner;
	int lock_depth;	/* Against recursive locks */
	struct xt_thread_s *waitq;
} xt_mutex_t;


void _xt_mutex_lock(xt_mutex_t *);
int _xt_mutex_trylock(xt_mutex_t *);	/* Return -1/EBUSY of already locked */
void _xt_mutex_unlock(xt_mutex_t *);
void __xt_mutex_MM_unlock(xt_mutex_t *);	/* Maintainer mode */

/*
 * Condition variable
 */

typedef struct xt_cond_s {
	struct xt_thread_s *waitq;
} xt_cond_t;

void _xt_cond_signal(xt_cond_t *);	/* Unlocks one thread */
void _xt_cond_broadcast(xt_cond_t *);	/* Unlocks all threads */
int _xt_cond_timedwait(xt_cond_t *, int wait_msec); /* -1/ETIMEDOUT */
void _xt_cond_wait(xt_cond_t *);

#endif	/* __XT_LOCKS_H__ */
