#include "xt_int.h"

xt_thread_t *_xt_idle_thread = NULL;

void
_xt_scheduler() {
	static char runnable_runs = 0;

	/*
	 * Get the next waiting thread from the ring
	 * by shifting the ring
	 */
	if(_xt_runnable_ring) {
		if(++runnable_runs == 0) {
			/* Execute timers periodically */
			_xt_timer_work();
		}

		_xt_runnable_ring = _xt_runnable_ring->ring_member.thr_next;
		THR_RESTORE_CONTEXT(_xt_runnable_ring);
	} else {
		runnable_runs = 0;
		THR_RESTORE_CONTEXT(_xt_idle_thread);
	}

	abort();
}


void *
_xt_idle_thread_func(void *arg) {
	int sleep_ticks;

	(void)arg;

	while(1) {
		sleep_ticks = _xt_timer_work();
		if(_xt_runnable_ring)
			THR_SWITCH_CONTEXT;
		_xt_gather_events(NULL, 0, sleep_ticks * 10);
	}

	abort();
}
