/*
 * Internally used definitions.
 */
#ifndef	__XT_STRUCTS_H__
#define	__XT_STRUCTS_H__

#include "headers.h"
#include "xthr.h"
#include "xt_timer.h"
#include "xt_stack.h"
#include "xt_locks.h"

/*
 * Internal thread descriptor.
 */
typedef struct xt_thread_s {

	/*
	 * Descriptor of the place in the circular ring
	 * this thread belongs to
	 */
	struct {
		struct xt_thread_s **cur_ring;
		struct xt_thread_s *thr_prev;
		struct xt_thread_s *thr_next;
	} ring_member;

	/*
	 * Run-time data
	 */
	int saved_errno;	/* Each thread has it's own errno */

	/*
	 * Data for context switch.
	 */
	xt_stack_t *stack;
	jmp_buf context;

	/* Basic sleep timer */
	xt_timer_t timer;

	/* External threads waiting the end of this thread */
	xt_cond_t join_condition;

	/*
	 * Data for initialization and destruction.
	 */
	xio_thread_attrs thread_attrs;
	void *(*start_routine)(void *arg);
	void *arg;
	void *return_value;
} xt_thread_t;

#endif	/* __XT_STRUCTS_H__ */
