#include "xt_int.h"

#ifdef	__FreeBSD__

int
_xt_stdio_close(void *cookie) {
        return close(fileno((FILE *)cookie));
}

int
_xt_stdio_read(void *cookie, char *buf, int size) {
        return read(fileno((FILE *)cookie), buf, size);
}

int
_xt_stdio_write(void *cookie, const char *buf, int size) {
        return write(fileno((FILE *)cookie), buf, size);
}

int
_xt_prepare_stdio(FILE *f) {

	if(f == NULL)
		return -1;

        f->_close = _xt_stdio_close;
        f->_read  = _xt_stdio_read;
        f->_write = _xt_stdio_write;

	/*
	 * Set non-blocking I/O,
	 */
	if(_xt_fd_nbio(fileno(f), 0))
		return -1;

        return 0;
}

#else

#error	Unknown system

#endif

