#ifndef	__XT_SYSDEPS_H__
#define	__XT_SYSDEPS_H__

/*
 * System/machine-dependent functions.
 */

int _xt_prepare_stdio(FILE *f);

#if defined(__FreeBSD__)

#define	THR_CONTEXT_INIT(_ctx, _sp, _fn)	\
	do {					\
		_setjmp(_ctx);			\
		_ctx[0]._jb[0] = (long)(_fn);	\
		_ctx[0]._jb[2] = (long)(_sp);	\
	} while(0);

#elif definen(__Linux__)

#define	THR_CONTEXT_INIT(_ctx, _sp, _fn)	\
	do {					\
		_setjmp(_ctx);			\
		_ctx[0].__jmpbuf[JB_PC] = (long)(_fn);	\
		_ctx[0].__jmpbuf[JB_SP] = (long)(_sp);	\
	} while(0);

#endif


/*
 * Machine-dependend macros.
 */

#define	THR_RESTORE_CONTEXT(thr)	\
	do {	\
		_xt_current_thread = (thr);	\
		errno = _xt_current_thread->saved_errno;	\
		_longjmp((thr)->context, 1);	\
	} while(0);

#define	THR_SWITCH_CONTEXT	do {	\
		if(_setjmp(_xt_current_thread->context) == 0) {	\
			_xt_current_thread->saved_errno = errno;	\
			_xt_scheduler();	\
		}	\
	} while(0);


#endif	/* __XT_SYSDEPS_H__ */
