/*
 * eXtended I/O driven threads.
 */
#ifndef	__XTHR_H__
#define	__XTHR_H__

typedef	void *	xio_thread_t;

#define	DEFAULT_THREAD_STACK_SIZE	16384

typedef struct {
	int joinable;
	int stack_size;
} xio_thread_attrs;

/*
 * Create a new thread, with attributes specified by
 * optional optThreadAttrs.
 */
int xio_thread_create(xio_thread_t *thread, xio_thread_attrs *optThreadAttrs,
	void *(*start_routine)(void *arg), void *arg);

/*
 * Wait for the target thread to complete.
 * value_ptr contains the return value of the
 * target thread's start_routine.
 * Return -1/EINVAL if thread is not a joinable thread.
 * Return -1/EDEADLK if deadlock occured (thread waiting for itself).
 * If a number of threads waiting the same thread, result is undefined.
 */
int xio_thread_join(xio_thread_t thread, void **value_ptr);

#endif	/* __XIOTHR_H__ */
